on startMovie
  CheckForValidName()
  InitGlobals()
  InitConditions()
  InitPuppets()
end

on CheckForValidName
  Flag = 0
  myMovie = the movieName
  repeat with temp = 1 to count(the windowList)
    if window(temp).title = "memmon" then
      Flag = 1
    end if
  end repeat
  if (the windowList = []) or not Flag then
    alert("Please open the memmon with the title Memmon.  Like this: From the message window, type - Open window " & QUOTE & "memmon" & QUOTE & ".   Open the main movie script for help.           Thank you, the management.        Attempting to auto open. ")
    alert("Please read the main movie script for instructions.  Also, you should rename the movie to be called memmon.  Then the movie should be opened from the message window.  It works best this way.   Use it to calculate data throughput off your CD Rom.  -Zav")
    open(window(the movieName))
    repeat with temp = 1 to count(the windowList)
      if window(1).title = myMovie then
        window("memmon").fileName = myMovie
        forget(window(myMovie))
        window("memmon").visible = 1
      end if
    end repeat
  end if
end

on InitGlobals
  global gBar, gOtherBar, gStartCast, gEndCast, gStartFrame, gEndFrame, gLevel, gTemp, gTempo
  gBar = 10
  gOtherBar = 26
  gStartCast = field("CastStart").value
  gEndCast = field("CastEnd").value
  gStartFrame = field("FrameStart").value
  gEndFrame = field("FrameEnd").value
  gTemp = 0
  gTempo = 5
  gLevel = 2
end

on InitConditions
  set the floatPrecision to 3
  window("memmon").windowType = 49
  put "-- Memmon v 2.44 by Alex Zavatone"
end

on InitPuppets
  global gBar
  puppetSprite(gBar, 1)
  puppetSprite(gOtherBar, 1)
  puppetSprite(29, 1)
  puppetSprite(30, 1)
  puppetSprite(31, 1)
  puppetSprite(32, 1)
  puppetSprite(33, 1)
  puppetSprite(34, 1)
end

on DoMe
  global gLevel
  UpdateGraph()
  if gLevel > 1 then
    UpdateFields()
  end if
end

on UpdateGraph
  global gBar, gOtherBar
  if voidp(gBar) then
    startMovie()
  end if
  set the height of sprite gBar to (cast("border").height * (the freeBytes * 1.0) / the memorysize) + 1.0
  set the height of sprite gOtherBar to (cast("border").height * (the freeBlock * 1.0) / the memorysize) + 1.0
end

on UpdateFields
  put the memorysize & " = " & the memorysize / 1024 & "k" into field "memsize"
  put the freeBytes & " = " & the freeBytes / 1024 & "k" into field "freebytes"
  put the freeBlock & " = " & the freeBlock / 1024 & "k" into field "freeblock"
  put the memorysize - the freeBytes & " = " & (the memorysize - the freeBytes) / 1024 & "k" into field "MemUsed"
end

on GetValues
  global gStartCast, gEndCast, gStartFrame, gEndFrame, gTemp
  gStartCast = field("CastStart").value
  gEndCast = field("CastEnd").value
  gStartFrame = field("FrameStart").value
  gEndFrame = field("FrameEnd").value
  tell the stage
    gTemp = the number of castMembers
  end tell
  if gEndCast > gTemp then
    gEndCast = gTemp
  end if
end

on startTimer
  return the ticks
end

on PutTime now
  delta = the ticks - now
  put "ticks = " & delta into field "delta t"
  put RETURN & "secs = " & delta / 60.0 after field "delta t"
  return delta
end

on InitTime
  global gNow
  gNow = the ticks
end

on CheckTime
  global gNow
  put the ticks - gNow
end

on GetStageCastSizes startcast, endcast, ignore
  total = 0
  if (startcast < 1) or (endcast < 1) then
    alert("An attempt was made to get the size of an invalid castmember.  Check your input values.")
    return 
  end if
  copyToClipboard(cast("GetCastSize script"))
  tell the stage
    pasteClipboardInto(cast(findEmpty(cast(1))))
  end tell
  if not ignore then
    repeat with temp = startcast to endcast
      tell the stage
        GetCastSize(temp)
      end tell
      total = total + the result
    end repeat
  else
  end if
  return total
end

on Throughput duration, total, ignore, freebytesAtStart
  if not ignore then
    if duration > 0 then
      if total > freebytesAtStart then
        total = freebytesAtStart
        put "-- Alert: amount of data to load exceeds freebytes"
      end if
      put total / 1024 & "k" & RETURN & integer(10 * total / 1024 / (duration / 60.0)) / 10.0 & "kps" into field "Throughput"
    else
      put total / 1024 & "k" & RETURN & "-- kps" into field "Throughput"
    end if
  else
    put "-- k" & RETURN & "-- kps" into field "Throughput"
  end if
  tell the stage
    cast("GetCastSize script").scriptText = EMPTY
  end tell
  tell the stage
    cast(the number of member "GetCastSize script").name = EMPTY
  end tell
end

on DoRight
  set the castNum of sprite the clickOn to the number of member "Left"
  wind = window("memmon")
  leftSide = getAt(wind.rect, 1)
  topSide = getAt(wind.rect, 2)
  rightSide = getAt(wind.rect, 3)
  bottomSide = getAt(wind.rect, 4)
  wind.rect = rect(leftSide, topSide, rightSide + 128, bottomSide)
end

on DoLeft
  set the castNum of sprite the clickOn to the number of member "Right"
  wind = window("memmon")
  leftSide = getAt(wind.rect, 1)
  topSide = getAt(wind.rect, 2)
  rightSide = getAt(wind.rect, 3)
  bottomSide = getAt(wind.rect, 4)
  wind.rect = rect(leftSide, topSide, rightSide - 128, bottomSide)
end

on DoUp arrow
  if voidp(arrow) then
    set the castNum of sprite the clickOn to the number of member "down"
  else
    set the castNum of sprite 29 to 0
    updateStage()
  end if
  wind = window("memmon")
  leftSide = getAt(wind.rect, 1)
  topSide = getAt(wind.rect, 2)
  rightSide = getAt(wind.rect, 3)
  bottomSide = getAt(wind.rect, 4)
  wind.rect = rect(leftSide, topSide, rightSide, bottomSide - 86)
end

on DoDown arrow
  if voidp(arrow) then
    set the castNum of sprite the clickOn to the number of member "up"
  else
    set the castNum of sprite 29 to the number of member "up"
  end if
  wind = window("memmon")
  leftSide = getAt(wind.rect, 1)
  topSide = getAt(wind.rect, 2)
  rightSide = getAt(wind.rect, 3)
  bottomSide = getAt(wind.rect, 4)
  wind.rect = rect(leftSide, topSide, rightSide, bottomSide + 86)
end

on GetMainMovieName
  global gMovie
  tell the stage
    gMovie = the movieName
  end tell
  put gMovie into field "Moviename"
end

on ResetTabButtons
  set the backColor of sprite 31 to 250
  set the backColor of sprite 32 to 245
  set the backColor of sprite 33 to 245
  set the backColor of sprite 34 to 245
end

on TurnOffDepthPuppets
  repeat with temp = 13 to 17
    puppetSprite(temp, 0)
  end repeat
end

on TurnOffVolumePuppets
  repeat with temp = 35 to 40
    puppetSprite(temp, 0)
    puppetSprite(temp, 0)
  end repeat
end

on UpdateMeters
  mainVolHeight = 64 - (9 * the soundLevel)
  set the height of sprite 35 to mainVolHeight
  set the locV of sprite 38 to 69 + mainVolHeight - 3
  mainVolHeight = 64 - (0.251 * the volume of sound 1)
  set the height of sprite 36 to mainVolHeight
  set the locV of sprite 39 to 69 + mainVolHeight - 3
  mainVolHeight = 64 - (0.251 * the volume of sound 2)
  set the height of sprite 37 to mainVolHeight
  set the locV of sprite 40 to 69 + mainVolHeight - 3
end

on Memmon
  go(1)
  window("memmon").rect = window("memmon").sourceRect
  open(window("memmon"))
end

on InitTempoIndicator
  global gTempo
  puppetSprite(22, 0)
  puppetSprite(22, 1)
  set the locV of sprite 22 to the bottom of sprite 21 - (gTempo * 3) - 1
end

on TurnOffTempoPuppets
  puppetSprite(22, 0)
end

on c
  clearGlobals()
  the windowList = []
end
